Require Import SigTS.




Module Type SigCompMod(TS: SigTSMod)(TS' : SigTSMod).

Parameter state_map : TS'.State -> TS.State.

Axiom state_map_inj : forall s'1 s'2 ,  state_map s'1 = state_map s'2 -> s'1 = s'2.


Axiom subtrans : forall s'1 s'2, TS'.trans s'1 s'2 -> TS.trans (state_map s'1) (state_map s'2). 

Axiom full_subtrans : forall s1 s2 s'1 s'2,
TS.trans s1 s2 -> state_map s'1 = s1 -> state_map s'2 = s2 -> TS'.trans s'1 s'2.

Definition isImage(a: TS.State)  := exists a',  a = state_map a'.

Axiom clean_border : forall (s'1:TS'.State) (s2:TS.State), 
    TS.trans (state_map s'1)  s2 ->
    ~isImage s2 -> TS'.final s'1.


Definition symState_map : TS'.SymState -> TS.SymState  :=
  fun p s =>
    exists s',  p s' /\ (s = state_map s').


End SigCompMod.
