Module Type SigTSMod.
  
  Parameter State : Type.
  Definition SymState : Type :=  State -> Prop.
  Definition top : SymState := fun _ => True.
  Definition bot : SymState := fun _ => False.
  Definition cnj(p q :SymState) := fun s => p s /\ q s.
  Definition dsj(p q :SymState) := fun s => p s \/ q s.
  Definition neg (p:SymState) := fun s => ~ p s.
  Definition imp(p q :SymState) := forall s, p s -> q s.

  Parameter trans : State -> State -> Prop.

  Definition final : SymState := fun s => forall s', ~ trans s s'.
  Definition symTrans(q:SymState) :=
    fun s => exists s', q s' /\ trans s' s.
End SigTSMod.  
