Require Import SigTS.


Definition isImage{T T': Type}(f : T' -> T) (a:T) := exists a',  a = f a'.

Module Type SigCompMod(TS: SigTSMod)(TS' : SigTSMod).

Parameter state_map : TS'.State -> TS.State.

Axiom state_map_inj : forall s'1 s'2 ,  state_map s'1 = state_map s'2 -> s'1 = s'2.


Axiom subtrans : forall s'1 s'2, TS'.trans s'1 s'2 -> TS.trans (state_map s'1) (state_map s'2). 

Axiom full_subtrans : forall s1 s2 s'1 s'2,
    TS.trans s1 s2 -> state_map s'1 = s1 ->  state_map s'2 = s2 ->   TS'.trans (s'1) (s'2).


Axiom clean_border : forall (s'1:TS'.State) (s2:TS.State), 
    TS.trans (state_map s'1)  s2 ->
    ~isImage state_map s2 -> TS'.final s'1.

End SigCompMod.
